# Волга ИТ - 2022. Прикладное программирование на С++

Основной тур

## Предисловие

Сентябрь 2004 года. Вы участвуете в первом в своем роде состязании беспилотных автомобилей `VolgaIT Grand Challenge`. До конкурса остался один день и уже завтра будут определены победители.

## Описание

Интерфейс работы с беспилотным автомобилем описан в папке `emulator`. К сожалению, подробностей не много. Код можно изучать и использовать его публичную (`public`) часть. Запрещено изменять этот код и получать доступ к его закрытой (`private`) части.

Известно, что автомобиль представлен в виде круга некоторого радиуса. Он едет по шоссе из нескольких непересекающихся полос прямоугольной формы с дорожными знаками. Совестно с ним едут другие участники дорожного движения. Необходимо проехать от начальной точки до точки назначения и остановиться за отведенное время. Дорога и дорожные знаки известны заранее, когда другие автомобили видны в определенном радиусе.

У автомобиля есть два режима (`hands on` ручной и `hands off` автоматический) и текстовый дисплей (он же навигатор или консоль). Режим задается один раз при запуске приложения и его можно узнать с помощью функции `Emulator::getMode()` (см. пример).

В процессе движения нельзя сталкиваться с другими автомобилями и выезжать за проезжую часть. Можно нарушать дорожные знаки в ущерб полученным за задание баллы (пропорционально времени нарушения).

Дорожный знак перекрывает предыдущее значение такого же дорожного знака.

Пример работы с автомобилем можно посмотреть в файле `main.cpp`. Файлы `input.txt` и `mode.txt` можно менять на свое усмотрение, но при тестировании организаторы олимпиады будут использоваться свои. Структуру файлов можно понять из кода, который их загружает и использует.

## Задание

Задания могут быть выполнены в любом порядке.

1. Сделать отображение дороги в навигаторе автомобиля (вид сверху) в текстовом виде (консоль)

   Для отображения символов в консоли можно использовать [функции](https://docs.microsoft.com/ru-ru/windows/console/console-reference) или любые другие функции Windows или Linux на ваше усмотрение.

   Необходимо отобразить как минимум полосы движения (или их границы), автомобиль участника, его скорость, автомобили других участников движения, дорожные знаки и точку назначения. Автомобиль участника должен быть на экране не зависимо от того, где он находится.

   Приветствуется использование интересных решений, символов, цветов, а так же отсутствие мерцания.

   Оценка: 125 баллов.

2. Доехать до точки назначения в автоматическом режиме `hands off` и остановиться

   2.1. По одной полосе пустой дороги.

   2.2. По одной полосе пустой дороги, соблюдая знаки дорожного движения.

   2.3. По многополосной пустой дороге, соблюдая знаки дорожного движения.

   2.4. С другими участниками дорожного движения, едущими по прямой, соблюдая знаки дорожного движения.

   2.5. С другими участниками дорожного движения, маневрирующими между различными полосами дороги.

   Оценка: по 125 баллов за каждый пункт.

3. Реализовать ручной режим управления автомобилем `hands on` посредтсвом клавиш:
   * `W` - вперед с текущей скоростью (не разгоняясь)
   * `A` - влево
   * `S` - назад с текущей скоростью (не замедляясь)
   * `D` - вправо
   * `E` - увеличить скорость
   * `Q` - уменьшить скорость.

   Оценка: 125 баллов.

## Поведение других автомобилей

Обычно другие автомобили едут по своей полосе. В более сложных тестах те могут набирать скорость, тормозить, маневрировать по полосе и перестраиваться в другую.

Кода манерирования нет в текущих исходниках `emulator`, но он подразумевается и будет туда добавлен в процессе тестирования.

## Ошибки и неточности в задании

По всем вопросам обращайтесь к организаторам олимпиады.

## Порядок сдачи работы

Работы сдается в виде собираемого исходного кода программы, исполняемого файла и документацией, в которой указан список сделанных заданий.
